use raylib::prelude::*;
use serde::{Deserialize, Serialize};

use crate::{input::Input, theme::FG_CHAPTER_TITLE, ui::text_button, Globals};

#[derive(Default, Debug, Clone, Serialize, Deserialize)]
pub struct Config {
	pub input: Input,
}

pub enum MenuReturn {
	Stay,
	StaySave,
	ReturnSave,
	ReturnCancel,
}

impl Config {
	#[must_use]
	pub fn draw_edit(&mut self, d: &mut RaylibDrawHandle, globals: &Globals) -> MenuReturn {
		d.draw_text("Settings", 16, 16, 30, FG_CHAPTER_TITLE);

		if text_button(d, &globals.mouse, 10, 60, 80, "apply") {
			return MenuReturn::StaySave;
		}
		if text_button(d, &globals.mouse, 100, 60, 80, "done") {
			return MenuReturn::ReturnSave;
		}
		if text_button(d, &globals.mouse, 190, 60, 80, "cancel") {
			return MenuReturn::ReturnCancel;
		}

		self.input.draw_edit(d, globals);
		MenuReturn::Stay
	}
}
